#!/usr/bin/python
# -*- coding: utf-8 -*-

import win32com
import win32com.client
import win32com.client.connect
import win32com.server.util
import pythoncom

mod = win32com.client.gencache.EnsureModule('{CAC1FA4D-46F4-4F9C-82B1-2807A80CC681}',0,1,0)


IID_ITestServerEvents = pythoncom.MakeIID("{FA2A6031-9FEE-4B34-B6D1-7D4C157CEDCE}")
class TestServerEventHandler:
    _public_methods_ = ["OnMyEvent"]
    
    def _query_interface_(self, iid):
        if iid == IID_ITestServerEvents:
            return win32com.server.util.wrap(self)
    
    def OnMyEvent(self, arg):
        print "client: event received:", arg

if __name__=='__main__':
    server = win32com.client.Dispatch("testproject.TestServer")
    print server #does not look like a makepy object
    
    server = win32com.client.DispatchWithEvents("testproject.TestServer", TestServerEventHandler)
    print server
    
    
    print server.fire_event(123)

